package withoutSync;

/**
 * Created by skazzi on 10/28/15.
 */
public class ChocolateWorld extends Thread
{
    Warehouse warehouse;
    Shop shops[];
    ChocolateEater eaters[];

    public ChocolateWorld() {
        warehouse = new Warehouse();
        shops = new Shop[4];
        for (int i = 0; i < 4; i++) {
            shops[i] = new Shop(warehouse);

            // shops restock from warehouse every 5 seconds
            shops[i].start();
        }


        // chocolate eaters eat x \in [1,7] chocolates every 0.5 seconds
        eaters = new ChocolateEater[100];
        for (int i = 0; i < eaters.length; i++) {
            eaters[i] = new ChocolateEater(shops);
        }

        start();
    }

    public int getTotalChocolate() {
        int sum = warehouse.getStorage();
        for (int i = 0; i < 4; i++) {
            sum += shops[i].getNumberOfChocolates();
        }
        for (int i = 0; i < 100; i++) {
            sum += eaters[i].getEaten();
        }

        return sum;
    }

    @Override
    public void run() {
        while (true) {
            try {
                Thread.sleep(1000);
                System.out.println("\nLOG:");
                System.out.println("Warehouse: " + warehouse.getStorage());
                for (int i = 0; i < 4; i++) {
                    System.out.println("Shop " + (i+1) + ": " + shops[i].getNumberOfChocolates());
                }
                int totalChocolate = getTotalChocolate();
                if (totalChocolate == 100000) System.out.println("Total chocolate: " + getTotalChocolate());
                else System.out.println("DESYNC! Total chocolate: " + totalChocolate);
                System.out.println();
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
        }
    }
}
